
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Modules in progress &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="modules-in-progress">
<h1>Modules in progress<a class="headerlink" href="#modules-in-progress" title="Permalink to this headline">¶</a></h1>
<p>There are several modules in the very initial development
state, and the help with them will be particularly
valuable. You are more than just welcome to help with:</p>
<span class="target" id="module-pyroute2.ipset"></span><p>ipset support.</p>
<p>This module is tested with hash:ip, hash:net, list:set and several
other ipset structures (like hash:net,iface). There is no guarantee
that this module is working with all available ipset modules.</p>
<p>It supports almost all kernel commands (create, destroy, flush,
rename, swap, test…)</p>
<dl class="class">
<dt id="pyroute2.ipset.PortRange">
<em class="property">class </em><code class="sig-prename descclassname">pyroute2.ipset.</code><code class="sig-name descname">PortRange</code><span class="sig-paren">(</span><em class="sig-param">begin</em>, <em class="sig-param">end</em>, <em class="sig-param">protocol=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.PortRange" title="Permalink to this definition">¶</a></dt>
<dd><p>A simple container for port range with optional protocol</p>
<p>Note that optional protocol parameter is not supported by all
kernel ipset modules using ports. On the other hand, it’s sometimes
mandatory to set it (like for hash:net,port ipsets)</p>
<p>Example:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">udp_proto</span> <span class="o">=</span> <span class="n">socket</span><span class="o">.</span><span class="n">getprotobyname</span><span class="p">(</span><span class="s2">&quot;udp&quot;</span><span class="p">)</span>
<span class="n">port_range</span> <span class="o">=</span> <span class="n">PortRange</span><span class="p">(</span><span class="mi">1000</span><span class="p">,</span> <span class="mi">2000</span><span class="p">,</span> <span class="n">protocol</span><span class="o">=</span><span class="n">udp_proto</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="s2">&quot;foo&quot;</span><span class="p">,</span> <span class="n">stype</span><span class="o">=</span><span class="s2">&quot;hash:net,port&quot;</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="s2">&quot;foo&quot;</span><span class="p">,</span> <span class="p">(</span><span class="s2">&quot;192.0.2.0/24&quot;</span><span class="p">,</span> <span class="n">port_range</span><span class="p">),</span> <span class="n">etype</span><span class="o">=</span><span class="s2">&quot;net,port&quot;</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">test</span><span class="p">(</span><span class="s2">&quot;foo&quot;</span><span class="p">,</span> <span class="p">(</span><span class="s2">&quot;192.0.2.0/24&quot;</span><span class="p">,</span> <span class="n">port_range</span><span class="p">),</span> <span class="n">etype</span><span class="o">=</span><span class="s2">&quot;net,port&quot;</span><span class="p">)</span>
</pre></div>
</div>
</dd></dl>

<dl class="class">
<dt id="pyroute2.ipset.PortEntry">
<em class="property">class </em><code class="sig-prename descclassname">pyroute2.ipset.</code><code class="sig-name descname">PortEntry</code><span class="sig-paren">(</span><em class="sig-param">port</em>, <em class="sig-param">protocol=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.PortEntry" title="Permalink to this definition">¶</a></dt>
<dd><p>A simple container for port entry with optional protocol</p>
</dd></dl>

<dl class="class">
<dt id="pyroute2.ipset.IPSet">
<em class="property">class </em><code class="sig-prename descclassname">pyroute2.ipset.</code><code class="sig-name descname">IPSet</code><span class="sig-paren">(</span><em class="sig-param">version=None</em>, <em class="sig-param">attr_revision=None</em>, <em class="sig-param">nfgen_family=2</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet" title="Permalink to this definition">¶</a></dt>
<dd><p>NFNetlink socket (family=NETLINK_NETFILTER).</p>
<p>Implements API to the ipset functionality.</p>
<dl class="method">
<dt id="pyroute2.ipset.IPSet.headers">
<code class="sig-name descname">headers</code><span class="sig-paren">(</span><em class="sig-param">name</em>, <em class="sig-param">**kwargs</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.headers" title="Permalink to this definition">¶</a></dt>
<dd><p>Get headers of the named ipset. It can be used to test if one ipset
exists, since it returns a no such file or directory.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.get_proto_version">
<code class="sig-name descname">get_proto_version</code><span class="sig-paren">(</span><em class="sig-param">version=6</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.get_proto_version" title="Permalink to this definition">¶</a></dt>
<dd><p>Get supported protocol version by kernel.</p>
<p>version parameter allow to set mandatory (but unused?)
IPSET_ATTR_PROTOCOL netlink attribute in the request.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.list">
<code class="sig-name descname">list</code><span class="sig-paren">(</span><em class="sig-param">*argv</em>, <em class="sig-param">**kwargs</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.list" title="Permalink to this definition">¶</a></dt>
<dd><p>List installed ipsets. If <cite>name</cite> is provided, list
the named ipset or return an empty list.</p>
<p>Be warned: netlink does not return an error if given name does not
exit, you will receive an empty list.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.destroy">
<code class="sig-name descname">destroy</code><span class="sig-paren">(</span><em class="sig-param">name=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.destroy" title="Permalink to this definition">¶</a></dt>
<dd><p>Destroy one (when name is set) or all ipset (when name is None)</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.create">
<code class="sig-name descname">create</code><span class="sig-paren">(</span><em class="sig-param">name</em>, <em class="sig-param">stype='hash:ip'</em>, <em class="sig-param">family=&lt;AddressFamily.AF_INET: 2&gt;</em>, <em class="sig-param">exclusive=True</em>, <em class="sig-param">counters=False</em>, <em class="sig-param">comment=False</em>, <em class="sig-param">maxelem=None</em>, <em class="sig-param">forceadd=False</em>, <em class="sig-param">hashsize=None</em>, <em class="sig-param">timeout=None</em>, <em class="sig-param">bitmap_ports_range=None</em>, <em class="sig-param">size=None</em>, <em class="sig-param">skbinfo=False</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.create" title="Permalink to this definition">¶</a></dt>
<dd><p>Create an ipset <cite>name</cite> of type <cite>stype</cite>, by default
<cite>hash:ip</cite>.</p>
<p>Common ipset options are supported:</p>
<ul class="simple">
<li><p>exclusive – if set, raise an error if the ipset exists</p></li>
<li><p>counters – enable data/packets counters</p></li>
<li><p>comment – enable comments capability</p></li>
<li><p>maxelem – max size of the ipset</p></li>
<li><p>forceadd – you should refer to the ipset manpage</p></li>
<li><p>hashsize – size of the hashtable (if any)</p></li>
<li><p>timeout – enable and set a default value for entries (if not None)</p></li>
<li><dl class="simple">
<dt>bitmap_ports_range – set the specified inclusive portrange for</dt><dd><p>the bitmap ipset structure (0, 65536)</p>
</dd>
</dl>
</li>
<li><p>size – Size of the list:set, the default is 8</p></li>
<li><p>skbinfo – enable skbinfo capability</p></li>
</ul>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.add">
<code class="sig-name descname">add</code><span class="sig-paren">(</span><em class="sig-param">name</em>, <em class="sig-param">entry</em>, <em class="sig-param">family=&lt;AddressFamily.AF_INET: 2&gt;</em>, <em class="sig-param">exclusive=True</em>, <em class="sig-param">comment=None</em>, <em class="sig-param">timeout=None</em>, <em class="sig-param">etype='ip'</em>, <em class="sig-param">skbmark=None</em>, <em class="sig-param">skbprio=None</em>, <em class="sig-param">skbqueue=None</em>, <em class="sig-param">wildcard=False</em>, <em class="sig-param">**kwargs</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.add" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a member to the ipset.</p>
<p>etype is the entry type that you add to the ipset. It’s related to
the ipset type. For example, use “ip” for one hash:ip or bitmap:ip
ipset.</p>
<p>When your ipset store a tuple, like “hash:net,iface”, you must use a
comma a separator (etype=”net,iface”)</p>
<p>entry is a string for “ip” and “net” objects. For ipset with several
dimensions, you must use a tuple (or a list) of objects.</p>
<p>“port” type is specific, since you can use integer of specialized
containers like <a class="reference internal" href="ipset.html#pyroute2.ipset.PortEntry" title="pyroute2.ipset.PortEntry"><code class="xref py py-class docutils literal notranslate"><span class="pre">PortEntry</span></code></a> and <a class="reference internal" href="ipset.html#pyroute2.ipset.PortRange" title="pyroute2.ipset.PortRange"><code class="xref py py-class docutils literal notranslate"><span class="pre">PortRange</span></code></a></p>
<p>Examples:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">ipset</span> <span class="o">=</span> <span class="n">IPSet</span><span class="p">()</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="s2">&quot;foo&quot;</span><span class="p">,</span> <span class="n">stype</span><span class="o">=</span><span class="s2">&quot;hash:ip&quot;</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="s2">&quot;foo&quot;</span><span class="p">,</span> <span class="s2">&quot;198.51.100.1&quot;</span><span class="p">,</span> <span class="n">etype</span><span class="o">=</span><span class="s2">&quot;ip&quot;</span><span class="p">)</span>

<span class="n">ipset</span> <span class="o">=</span> <span class="n">IPSet</span><span class="p">()</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="s2">&quot;bar&quot;</span><span class="p">,</span> <span class="n">stype</span><span class="o">=</span><span class="s2">&quot;bitmap:port&quot;</span><span class="p">,</span>
             <span class="n">bitmap_ports_range</span><span class="o">=</span><span class="p">(</span><span class="mi">1000</span><span class="p">,</span> <span class="mi">2000</span><span class="p">))</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="s2">&quot;bar&quot;</span><span class="p">,</span> <span class="mi">1001</span><span class="p">,</span> <span class="n">etype</span><span class="o">=</span><span class="s2">&quot;port&quot;</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="s2">&quot;bar&quot;</span><span class="p">,</span> <span class="n">PortRange</span><span class="p">(</span><span class="mi">1500</span><span class="p">,</span> <span class="mi">2000</span><span class="p">),</span> <span class="n">etype</span><span class="o">=</span><span class="s2">&quot;port&quot;</span><span class="p">)</span>

<span class="n">ipset</span> <span class="o">=</span> <span class="n">IPSet</span><span class="p">()</span>
<span class="kn">import</span> <span class="nn">socket</span>
<span class="n">protocol</span> <span class="o">=</span> <span class="n">socket</span><span class="o">.</span><span class="n">getprotobyname</span><span class="p">(</span><span class="s2">&quot;tcp&quot;</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="s2">&quot;foobar&quot;</span><span class="p">,</span> <span class="n">stype</span><span class="o">=</span><span class="s2">&quot;hash:net,port&quot;</span><span class="p">)</span>
<span class="n">port_entry</span> <span class="o">=</span> <span class="n">PortEntry</span><span class="p">(</span><span class="mi">80</span><span class="p">,</span> <span class="n">protocol</span><span class="o">=</span><span class="n">protocol</span><span class="p">)</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="s2">&quot;foobar&quot;</span><span class="p">,</span> <span class="p">(</span><span class="s2">&quot;198.51.100.0/24&quot;</span><span class="p">,</span> <span class="n">port_entry</span><span class="p">),</span>
          <span class="n">etype</span><span class="o">=</span><span class="s2">&quot;net,port&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>wildcard option enable kernel wildcard matching on interface
name for net,iface entries.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.delete">
<code class="sig-name descname">delete</code><span class="sig-paren">(</span><em class="sig-param">name</em>, <em class="sig-param">entry</em>, <em class="sig-param">family=&lt;AddressFamily.AF_INET: 2&gt;</em>, <em class="sig-param">exclusive=True</em>, <em class="sig-param">etype='ip'</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.delete" title="Permalink to this definition">¶</a></dt>
<dd><p>Delete a member from the ipset.</p>
<p>See <a class="reference internal" href="ipset.html#pyroute2.ipset.IPSet.add" title="pyroute2.ipset.IPSet.add"><code class="xref py py-func docutils literal notranslate"><span class="pre">add()</span></code></a> method for more information on etype.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.test">
<code class="sig-name descname">test</code><span class="sig-paren">(</span><em class="sig-param">name</em>, <em class="sig-param">entry</em>, <em class="sig-param">family=&lt;AddressFamily.AF_INET: 2&gt;</em>, <em class="sig-param">etype='ip'</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.test" title="Permalink to this definition">¶</a></dt>
<dd><p>Test if entry is part of an ipset</p>
<p>See <a class="reference internal" href="ipset.html#pyroute2.ipset.IPSet.add" title="pyroute2.ipset.IPSet.add"><code class="xref py py-func docutils literal notranslate"><span class="pre">add()</span></code></a> method for more information on etype.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.swap">
<code class="sig-name descname">swap</code><span class="sig-paren">(</span><em class="sig-param">set_a</em>, <em class="sig-param">set_b</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.swap" title="Permalink to this definition">¶</a></dt>
<dd><p>Swap two ipsets. They must have compatible content type.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.flush">
<code class="sig-name descname">flush</code><span class="sig-paren">(</span><em class="sig-param">name=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.flush" title="Permalink to this definition">¶</a></dt>
<dd><p>Flush all ipsets. When name is set, flush only this ipset.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.rename">
<code class="sig-name descname">rename</code><span class="sig-paren">(</span><em class="sig-param">name_src</em>, <em class="sig-param">name_dst</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.rename" title="Permalink to this definition">¶</a></dt>
<dd><p>Rename the ipset.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.get_set_byname">
<code class="sig-name descname">get_set_byname</code><span class="sig-paren">(</span><em class="sig-param">name</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.get_set_byname" title="Permalink to this definition">¶</a></dt>
<dd><p>Get a set by its name</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.get_set_byindex">
<code class="sig-name descname">get_set_byindex</code><span class="sig-paren">(</span><em class="sig-param">index</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.get_set_byindex" title="Permalink to this definition">¶</a></dt>
<dd><p>Get a set by its index</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.ipset.IPSet.get_supported_revisions">
<code class="sig-name descname">get_supported_revisions</code><span class="sig-paren">(</span><em class="sig-param">stype</em>, <em class="sig-param">family=&lt;AddressFamily.AF_INET: 2&gt;</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.ipset.IPSet.get_supported_revisions" title="Permalink to this definition">¶</a></dt>
<dd><p>Return minimum and maximum of revisions supported by the kernel.</p>
<p>Each ipset module (like hash:net, hash:ip, etc) has several
revisions. Newer revisions often have more features or more
performances. Thanks to this call, you can ask the kernel
the list of supported revisions.</p>
<p>You can manually set/force revisions used in IPSet constructor.</p>
<p>Example:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">ipset</span> <span class="o">=</span> <span class="n">IPSet</span><span class="p">()</span>
<span class="n">ipset</span><span class="o">.</span><span class="n">get_supported_revisions</span><span class="p">(</span><span class="s2">&quot;hash:net&quot;</span><span class="p">)</span>

<span class="n">ipset</span><span class="o">.</span><span class="n">get_supported_revisions</span><span class="p">(</span><span class="s2">&quot;hash:net,port,net&quot;</span><span class="p">)</span>
</pre></div>
</div>
</dd></dl>

</dd></dl>

<span class="target" id="module-pyroute2.iwutil"></span><div class="section" id="iw-module">
<h2>IW module<a class="headerlink" href="#iw-module" title="Permalink to this headline">¶</a></h2>
<p>Experimental wireless module — nl80211 support.</p>
<div class="section" id="disclaimer">
<h3>Disclaimer<a class="headerlink" href="#disclaimer" title="Permalink to this headline">¶</a></h3>
<p>Unlike IPRoute, which is mostly usable, though is far from
complete yet, the IW module is in the very initial state.
Neither the module itself, nor the message class cover the
nl80211 functionality reasonably enough. So if you’re
going to use it, brace yourself — debug is coming.</p>
</div>
<div class="section" id="messages">
<h3>Messages<a class="headerlink" href="#messages" title="Permalink to this headline">¶</a></h3>
<p>nl80211 messages are defined here:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pyroute2</span><span class="o">/</span><span class="n">netlink</span><span class="o">/</span><span class="n">nl80211</span><span class="o">/</span><span class="fm">__init__</span><span class="o">.</span><span class="n">py</span>
</pre></div>
</div>
<p>Pls notice NLAs of type <cite>hex</cite>. On the early development stage
<cite>hex</cite> allows to inspect incoming data as a hex dump and,
occasionally, even make requests with such NLAs. But it’s
not a production way.</p>
<p>The type <cite>hex</cite> in the NLA definitions means that this
particular NLA is not handled yet properly. If you want to
use some NLA which is defined as <cite>hex</cite> yet, pls find out a
specific type, patch the message class and submit your pull
request on github.</p>
<p>If you’re not familiar with NLA types, take a look at RTNL
definitions:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pyroute2</span><span class="o">/</span><span class="n">netlink</span><span class="o">/</span><span class="n">rtnl</span><span class="o">/</span><span class="n">ndmsg</span><span class="o">.</span><span class="n">py</span>
</pre></div>
</div>
<p>and so on.</p>
</div>
<div class="section" id="communication-with-the-kernel">
<h3>Communication with the kernel<a class="headerlink" href="#communication-with-the-kernel" title="Permalink to this headline">¶</a></h3>
<p>There are several methods of the communication with the kernel.</p>
<blockquote>
<div><ul class="simple">
<li><p><cite>sendto()</cite> — lowest possible, send a raw binary data</p></li>
<li><p><cite>put()</cite> — send a netlink message</p></li>
<li><p><cite>nlm_request()</cite> — send a message, return the response</p></li>
<li><p><cite>get()</cite> — get a netlink message</p></li>
<li><p><cite>recv()</cite> — get a raw binary data from the kernel</p></li>
</ul>
</div></blockquote>
<p>There are no errors on <cite>put()</cite> usually. Any <cite>permission denied</cite>,
any <cite>invalid value</cite> errors are returned from the kernel with
netlink also. So if you do <cite>put()</cite>, but don’t do <cite>get()</cite>, be
prepared to miss errors.</p>
<p>The preferred method for the communication is <cite>nlm_request()</cite>.
It tracks the message ID, returns the corresponding response.
In the case of errors <cite>nlm_request()</cite> raises an exception.
To get the response on any operation with nl80211, use flag
<cite>NLM_F_ACK</cite>.</p>
</div>
<div class="section" id="reverse-it">
<h3>Reverse it<a class="headerlink" href="#reverse-it" title="Permalink to this headline">¶</a></h3>
<p>If you’re too lazy to read the kernel sources, but still need
something not implemented here, you can use reverse engineering
on a reference implementation. E.g.:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># strace -e trace=network -f -x -s 4096 \</span>
        <span class="n">iw</span> <span class="n">phy</span> <span class="n">phy0</span> <span class="n">interface</span> <span class="n">add</span> <span class="n">test</span> <span class="nb">type</span> <span class="n">monitor</span>
</pre></div>
</div>
<p>Will dump all the netlink traffic between the program <cite>iw</cite> and
the kernel. Three first packets are the generic netlink protocol
discovery, you can ignore them. All that follows, is the
nl80211 traffic:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">sendmsg</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="p">{</span><span class="n">msg_name</span><span class="p">(</span><span class="mi">12</span><span class="p">)</span><span class="o">=</span><span class="p">{</span><span class="n">sa_family</span><span class="o">=</span><span class="n">AF_NETLINK</span><span class="p">,</span> <span class="o">...</span> <span class="p">},</span>
    <span class="n">msg_iov</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span><span class="o">=</span><span class="p">[{</span><span class="s2">&quot;</span><span class="se">\x30\x00\x00\x00\x1b\x00\x05</span><span class="s2"> ...&quot;</span><span class="p">,</span> <span class="mi">48</span><span class="p">}],</span>
    <span class="n">msg_controllen</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">msg_flags</span><span class="o">=</span><span class="mi">0</span><span class="p">},</span> <span class="mi">0</span><span class="p">)</span> <span class="o">=</span> <span class="mi">48</span>
<span class="n">recvmsg</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="p">{</span><span class="n">msg_name</span><span class="p">(</span><span class="mi">12</span><span class="p">)</span><span class="o">=</span><span class="p">{</span><span class="n">sa_family</span><span class="o">=</span><span class="n">AF_NETLINK</span><span class="p">,</span> <span class="o">...</span> <span class="p">},</span>
    <span class="n">msg_iov</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span><span class="o">=</span><span class="p">[{</span><span class="s2">&quot;</span><span class="se">\x58\x00\x00\x00\x1b\x00\x00</span><span class="s2"> ...&quot;</span><span class="p">,</span> <span class="mi">16384</span><span class="p">}],</span>
    <span class="n">msg_controllen</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">msg_flags</span><span class="o">=</span><span class="mi">0</span><span class="p">},</span> <span class="mi">0</span><span class="p">)</span> <span class="o">=</span> <span class="mi">88</span>
<span class="o">...</span>
</pre></div>
</div>
<p>With <cite>-s 4096</cite> you will get the full dump. Then copy the strings
from <cite>msg_iov</cite> to a file, let’s say <cite>data</cite>, and run the decoder:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ pwd
/home/user/Projects/pyroute2
$ export PYTHONPATH=`pwd`
$ python scripts/decoder.py pyroute2.netlink.nl80211.nl80211cmd data
</pre></div>
</div>
<p>You will get the session decoded:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">{</span><span class="s1">&#39;attrs&#39;</span><span class="p">:</span> <span class="p">[[</span><span class="s1">&#39;NL80211_ATTR_WIPHY&#39;</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_IFNAME&#39;</span><span class="p">,</span> <span class="s1">&#39;test&#39;</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_IFTYPE&#39;</span><span class="p">,</span> <span class="mi">6</span><span class="p">]],</span>
 <span class="s1">&#39;cmd&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span>
 <span class="s1">&#39;header&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;flags&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span>
            <span class="s1">&#39;length&#39;</span><span class="p">:</span> <span class="mi">48</span><span class="p">,</span>
            <span class="s1">&#39;pid&#39;</span><span class="p">:</span> <span class="mi">3292542647</span><span class="p">,</span>
            <span class="s1">&#39;sequence_number&#39;</span><span class="p">:</span> <span class="mi">1430426434</span><span class="p">,</span>
            <span class="s1">&#39;type&#39;</span><span class="p">:</span> <span class="mi">27</span><span class="p">},</span>
 <span class="s1">&#39;reserved&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
 <span class="s1">&#39;version&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">}</span>
<span class="p">{</span><span class="s1">&#39;attrs&#39;</span><span class="p">:</span> <span class="p">[[</span><span class="s1">&#39;NL80211_ATTR_IFINDEX&#39;</span><span class="p">,</span> <span class="mi">23811</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_IFNAME&#39;</span><span class="p">,</span> <span class="s1">&#39;test&#39;</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_WIPHY&#39;</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_IFTYPE&#39;</span><span class="p">,</span> <span class="mi">6</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_WDEV&#39;</span><span class="p">,</span> <span class="mi">4</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_MAC&#39;</span><span class="p">,</span> <span class="s1">&#39;a4:4e:31:43:1c:7c&#39;</span><span class="p">],</span>
           <span class="p">[</span><span class="s1">&#39;NL80211_ATTR_GENERATION&#39;</span><span class="p">,</span> <span class="s1">&#39;02:00:00:00&#39;</span><span class="p">]],</span>
 <span class="s1">&#39;cmd&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span>
 <span class="s1">&#39;header&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;flags&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
            <span class="s1">&#39;length&#39;</span><span class="p">:</span> <span class="mi">88</span><span class="p">,</span>
            <span class="s1">&#39;pid&#39;</span><span class="p">:</span> <span class="mi">3292542647</span><span class="p">,</span>
            <span class="s1">&#39;sequence_number&#39;</span><span class="p">:</span> <span class="mi">1430426434</span><span class="p">,</span>
            <span class="s1">&#39;type&#39;</span><span class="p">:</span> <span class="mi">27</span><span class="p">},</span>
 <span class="s1">&#39;reserved&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
 <span class="s1">&#39;version&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">}</span>
</pre></div>
</div>
<p>Now you know, how to do a request and what you will get as a
response. Sample collected data is in the <cite>scripts</cite> directory.</p>
</div>
<div class="section" id="submit-changes">
<h3>Submit changes<a class="headerlink" href="#submit-changes" title="Permalink to this headline">¶</a></h3>
<p>Please do not hesitate to submit the changes on github. Without
your patches this module will not evolve.</p>
<dl class="class">
<dt id="pyroute2.iwutil.IW">
<em class="property">class </em><code class="sig-prename descclassname">pyroute2.iwutil.</code><code class="sig-name descname">IW</code><span class="sig-paren">(</span><em class="sig-param">*argv</em>, <em class="sig-param">**kwarg</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="pyroute2.iwutil.IW.del_interface">
<code class="sig-name descname">del_interface</code><span class="sig-paren">(</span><em class="sig-param">dev</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.del_interface" title="Permalink to this definition">¶</a></dt>
<dd><p>Delete a virtual interface</p>
<blockquote>
<div><ul class="simple">
<li><p>dev — device index</p></li>
</ul>
</div></blockquote>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.add_interface">
<code class="sig-name descname">add_interface</code><span class="sig-paren">(</span><em class="sig-param">ifname</em>, <em class="sig-param">iftype</em>, <em class="sig-param">dev=None</em>, <em class="sig-param">phy=0</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.add_interface" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a virtual interface</p>
<blockquote>
<div><ul class="simple">
<li><p>ifname — name of the interface to create</p></li>
<li><p>iftype — interface type to create</p></li>
<li><p>dev — device index</p></li>
<li><p>phy — phy index</p></li>
</ul>
</div></blockquote>
<p>One should specify <cite>dev</cite> (device index) or <cite>phy</cite>
(phy index). If no one specified, phy == 0.</p>
<p><cite>iftype</cite> can be integer or string:</p>
<ol class="arabic simple">
<li><p>adhoc</p></li>
<li><p>station</p></li>
<li><p>ap</p></li>
<li><p>ap_vlan</p></li>
<li><p>wds</p></li>
<li><p>monitor</p></li>
<li><p>mesh_point</p></li>
<li><p>p2p_client</p></li>
<li><p>p2p_go</p></li>
<li><p>p2p_device</p></li>
<li><p>ocb</p></li>
</ol>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.list_dev">
<code class="sig-name descname">list_dev</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.list_dev" title="Permalink to this definition">¶</a></dt>
<dd><p>Get list of all wifi network interfaces</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.list_wiphy">
<code class="sig-name descname">list_wiphy</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.list_wiphy" title="Permalink to this definition">¶</a></dt>
<dd><p>Get list of all phy devices</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.get_interfaces_dict">
<code class="sig-name descname">get_interfaces_dict</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.get_interfaces_dict" title="Permalink to this definition">¶</a></dt>
<dd><p>Get interfaces dictionary</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.get_interfaces_dump">
<code class="sig-name descname">get_interfaces_dump</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.get_interfaces_dump" title="Permalink to this definition">¶</a></dt>
<dd><p>Get interfaces dump</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.get_interface_by_phy">
<code class="sig-name descname">get_interface_by_phy</code><span class="sig-paren">(</span><em class="sig-param">attr</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.get_interface_by_phy" title="Permalink to this definition">¶</a></dt>
<dd><p>Get interface by phy ( use x.get_attr(‘NL80211_ATTR_WIPHY’) )</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.get_interface_by_ifindex">
<code class="sig-name descname">get_interface_by_ifindex</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.get_interface_by_ifindex" title="Permalink to this definition">¶</a></dt>
<dd><p>Get interface by ifindex ( use x.get_attr(‘NL80211_ATTR_IFINDEX’)</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.get_stations">
<code class="sig-name descname">get_stations</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.get_stations" title="Permalink to this definition">¶</a></dt>
<dd><p>Get stations by ifindex</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.join_ibss">
<code class="sig-name descname">join_ibss</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">ssid</em>, <em class="sig-param">freq</em>, <em class="sig-param">bssid=None</em>, <em class="sig-param">channel_fixed=False</em>, <em class="sig-param">width=None</em>, <em class="sig-param">center=None</em>, <em class="sig-param">center2=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.join_ibss" title="Permalink to this definition">¶</a></dt>
<dd><dl class="simple">
<dt>Connect to network by ssid</dt><dd><ul class="simple">
<li><p>ifindex - IFINDEX of the interface to perform the connection</p></li>
<li><p>ssid - Service set identification</p></li>
<li><p>freq - Frequency in MHz</p></li>
<li><p>bssid - The MAC address of target interface</p></li>
<li><p>channel_fixed: Boolean flag</p></li>
<li><p>width - Channel width</p></li>
<li><p>center - Central frequency of the 40/80/160 MHz channel</p></li>
<li><p>center2 - Center frequency of second segment if 80P80</p></li>
</ul>
</dd>
</dl>
<p>If the flag of channel_fixed is True, one should specify both the width
and center of the channel</p>
<p><cite>width</cite> can be integer of string:</p>
<ol class="arabic simple" start="0">
<li><p>20_noht</p></li>
<li><p>20</p></li>
<li><p>40</p></li>
<li><p>80</p></li>
<li><p>80p80</p></li>
<li><p>160</p></li>
<li><p>5</p></li>
<li><p>10</p></li>
</ol>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.leave_ibss">
<code class="sig-name descname">leave_ibss</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.leave_ibss" title="Permalink to this definition">¶</a></dt>
<dd><p>Leave the IBSS – the IBSS is determined by the network interface</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.authenticate">
<code class="sig-name descname">authenticate</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">bssid</em>, <em class="sig-param">ssid</em>, <em class="sig-param">freq</em>, <em class="sig-param">auth_type=0</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.authenticate" title="Permalink to this definition">¶</a></dt>
<dd><p>Send an Authentication management frame.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.deauthenticate">
<code class="sig-name descname">deauthenticate</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">bssid</em>, <em class="sig-param">reason_code=1</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.deauthenticate" title="Permalink to this definition">¶</a></dt>
<dd><p>Send a Deauthentication management frame.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.associate">
<code class="sig-name descname">associate</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">bssid</em>, <em class="sig-param">ssid</em>, <em class="sig-param">freq</em>, <em class="sig-param">info_elements=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.associate" title="Permalink to this definition">¶</a></dt>
<dd><p>Send an Association request frame.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.disassociate">
<code class="sig-name descname">disassociate</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">bssid</em>, <em class="sig-param">reason_code=3</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.disassociate" title="Permalink to this definition">¶</a></dt>
<dd><p>Send a Disassociation management frame.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.connect">
<code class="sig-name descname">connect</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">ssid</em>, <em class="sig-param">bssid=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.connect" title="Permalink to this definition">¶</a></dt>
<dd><p>Connect to the ap with ssid and bssid</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.disconnect">
<code class="sig-name descname">disconnect</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.disconnect" title="Permalink to this definition">¶</a></dt>
<dd><p>Disconnect the device</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.scan">
<code class="sig-name descname">scan</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em>, <em class="sig-param">ssids=None</em>, <em class="sig-param">flush_cache=False</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.scan" title="Permalink to this definition">¶</a></dt>
<dd><p>Trigger scan and get results.</p>
<p>Triggering scan usually requires root, and can take a
couple of seconds.</p>
</dd></dl>

<dl class="method">
<dt id="pyroute2.iwutil.IW.get_associated_bss">
<code class="sig-name descname">get_associated_bss</code><span class="sig-paren">(</span><em class="sig-param">ifindex</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.iwutil.IW.get_associated_bss" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the same info like scan() does, but only about the
currently associated BSS.</p>
<p>Unlike scan(), it returns immediately and doesn’t require root.</p>
</dd></dl>

</dd></dl>

</div>
</div>
<div class="section" id="network-settings-daemon-pyrouted">
<h2>Network settings daemon – pyrouted<a class="headerlink" href="#network-settings-daemon-pyrouted" title="Permalink to this headline">¶</a></h2>
<p>Pyrouted is a standalone project of a system service, that
utilizes the <cite>pyroute2</cite> library. It consists of a daemon
controlled by <cite>systemd</cite> and a CLI utility that communicates
with the daemon via UNIX socket.</p>
<ul class="simple">
<li><p>home: <a class="reference external" href="https://github.com/svinota/pyrouted">https://github.com/svinota/pyrouted</a></p></li>
<li><p>bugs: <a class="reference external" href="https://github.com/svinota/pyrouted/issues">https://github.com/svinota/pyrouted/issues</a></p></li>
<li><p>pypi: <a class="reference external" href="https://pypi.python.org/pypi/pyrouted">https://pypi.python.org/pypi/pyrouted</a></p></li>
</ul>
<p>It is an extremely simple and basic network interface setup
tool.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Modules in progress</a><ul>
<li><a class="reference internal" href="#iw-module">IW module</a><ul>
<li><a class="reference internal" href="#disclaimer">Disclaimer</a></li>
<li><a class="reference internal" href="#messages">Messages</a></li>
<li><a class="reference internal" href="#communication-with-the-kernel">Communication with the kernel</a></li>
<li><a class="reference internal" href="#reverse-it">Reverse it</a></li>
<li><a class="reference internal" href="#submit-changes">Submit changes</a></li>
</ul>
</li>
<li><a class="reference internal" href="#network-settings-daemon-pyrouted">Network settings daemon – pyrouted</a></li>
</ul>
</li>
</ul>

  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/devmodules.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>